Summary: String library, very low memory overhead, simple to import
Name: ustr
Version: 1.0.4
Release: 6%{?dist}
License: MIT or LGPLv2+ or BSD
URL: http://www.and.org/ustr/
Source0: http://www.and.org/ustr/%{version}/%{name}-%{version}.tar.bz2

Patch3000: c99-inline.patch

BuildRequires: make gcc

%description
This package provides a low overhead string library for C, it is been designed to 
make integrating a string library into any C project easy. The default overhead 
over using plain strdup("a") is 4 used bytes (on i386 or x86-64), and for this 
you get reference counted length managed strings. This overhead grows to 5 used 
bytes for 256 byte strings, and 7 bytes for 65,536 character strings.
This package also distributes pre-built shared libraries.


%package devel
Summary: Development files for ustr

Requires: pkgconfig >= 0.14
Requires: ustr = %{version}-%{release}

%description devel
This package provides header files and .so files
for the Ustr string library.
It includes a ustr.pc file for pkg-config usage and
the ustr-import tool for including the code in projects.


%package static
Summary: Static development files for ustr
Requires: ustr-devel = %{version}-%{release}

%description static
This package provides static library for the Ustr string library.


%package debug
Summary: Development files for ustr, with debugging options turned on
Requires: pkgconfig >= 0.14
Requires: ustr-devel = %{version}-%{release}

%description debug
This package provides header files and dynamic libraries for a debug 
build of the Ustr string library. It also includes a ustr-debug.pc 
file for pkg-config usage.


%package debug-static
Summary: Static development files for ustr, with debugging options turned on
Requires: ustr-debug = %{version}-%{release}

%description debug-static
This package provides tatic library for the debug build of the Ustr string library.


%prep
%autosetup


%build
make %{?_smp_mflags} all-shared CFLAGS="${RPM_OPT_FLAGS}  -fgnu89-inline" \
  LDFLAGS="$RPM_LD_FLAGS" HIDE=


%check
make %{?_smp_mflags} check CFLAGS="${RPM_OPT_FLAGS}  -fgnu89-inline" \
  LDFLAGS="$RPM_LD_FLAGS" HIDE=


%install
rm -rf %{buildroot}
make $@ install-multilib-linux mandir=%{_mandir} libdir=%{_libdir} \
DOCSHRDIR=%{_datadir}/doc/ustr-devel \
DESTDIR=%{buildroot} LDCONFIG=/bin/true HIDE=


%files
%license LICENSE*
%doc ChangeLog README NEWS
%{_libdir}/libustr-1.0.so.*

%files devel
%{_bindir}/ustr-import
%{_libexecdir}/ustr-%{version}
%exclude %{_includedir}/ustr*debug*.h
%{_includedir}/ustr.h
%{_includedir}/ustr-*.h
%{_libdir}/pkgconfig/ustr.pc
%{_libdir}/libustr.so
%{_datadir}/doc/ustr-devel
%{_datadir}/ustr-%{version}
%{_mandir}/man1/*
%{_mandir}/man3/*

%files static
%{_libdir}/libustr.a

%files debug
%{_libdir}/libustr-debug-1.0.so.*
%{_libdir}/libustr-debug.so
%{_libdir}/pkgconfig/ustr-debug.pc
%{_includedir}/ustr*debug*.h

%files debug-static
%{_libdir}/libustr-debug.a


%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.0.4-6
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.0.4-5
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.0.4-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.0.4-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.0.4-2
- Rebuilt for OpenCloudOS Stream 23

* Tue Jul 19 2022 Yi Lin <nilusyi@tencent.com> - 1.0.4-1
- package init.
